<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.4/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container">
        <h1>Login Form</h1>
        <form action="" id="loginForm">
            <div>
                <label for="email">Email Address</label>
                <input class="form-control" type="text" id="email" placeholder="Enter Email" />
                <p style="color: #B2B8BC">we'll never share your email with anyone else</p>
            </div>
            <div>
                <label for="password">Password</label>
                <input class="form-control" type="password" id="password" placeholder="Password" />
            </div>
            <br>
            <div>
                <input class="btn btn-primary" type="submit" value="Submit" />
                <!-- <button class="btn btn-primary" >Submit</button> -->
            </div>
        </form>
    </div>
</body>

</html>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    var gLoginForm = document.getElementById("loginForm");
    gLoginForm.addEventListener("submit", function (e) {
        e.preventDefault(); // Ngăn chặn submit mặc định của form
        // Bước 0: Khởi tạo đối tượng thu thập
        var vObject = {
            email: "",
            password: ""
        }
        // Bước 1: thu thập dữ liệu
        getDataFromInput(vObject);
        console.log(vObject);
        // Bước 2: Kiểm tra dữ liệu thu thập
        var vCheck = validateData(vObject);
        console.log(vCheck);
        // Bước 3: gọi API xử lý
        if(vCheck == true){
            // create a request
            var vXmlHttpLogin = new XMLHttpRequest();
            processAPI(vXmlHttpLogin, vObject);
            vXmlHttpLogin.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginInfo = vXmlHttpLogin.responseText;                   
                    // Bước 4: hiển thị thông tin
                    displayData(vLoginInfo);
                }
            }
        }
        
    })
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị thông tin sau khi đăng nhập
    function displayData(paramInfor){
        "use strict";
        console.log(paramInfor);
    }
    // Hàm xử lý ajax API login
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject){
        "use strict";
        paramRequest.open("GET", gBASE_URL + "?" + paramObject.toString(), true);
        paramRequest.send();
    }
    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateData(paramObject) {
        "use strict";
        var vResult = true; // Khởi tạo kết quả kiểm tra là đúng

        var vEmail = paramObject.email.trim(); // Chuẩn hóa dữ liệu
        var vPass = paramObject.password.trim();

        if (vEmail == "") {
            alert("Email is empty!");
            vResult = false;
        } else {
            if (validateEmail(vEmail) == false) {
                alert("Email is invalid!");
                vResult = false;
            }
        }

        if (vPass == "") {
            alert("Password is empty!");
            vResult = false;
        }

        return vResult;
    }
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu thu thập
    function getDataFromInput(paramObject) {
        "use strict";
        var vEmail = document.getElementById("email");
        var vPass = document.getElementById("password");

        paramObject.email = vEmail.value;
        paramObject.password = vPass.value;
    }
</script>